searchNodes=[{"doc":"Liquid template renderer for Elixir with 100% compatibility with the Liquid gem by Shopify . Basic Usage iex&gt; { :ok , template_ast } = Liquex . parse ( &quot;Hello {{ name }}!&quot; ) iex&gt; context = Liquex.Context . new ( %{ &quot;name&quot; =&gt; &quot;World&quot; } ) iex&gt; { content , _context } = Liquex . render ( template_ast , context ) iex&gt; content |&gt; to_string ( ) &quot;Hello World!&quot; Supported features Currently, all standard Liquid tags, filters, and types are fully supported. Liquex can be considered a byte for byte drop in replacement of the Liquid gem. Lazy variables Liquex allows resolver functions for variables that may require some extra work to generate. For example, Shopify has variables for things like available products. Pulling all products every time would be too expensive to do on every render. Instead, it would be better to lazily pull that information as needed. Instead of adding the product list to the context variable map, you can add a function to the variable map. If a function is accessed in the variable map, it is executed. products_resolver = fn _parent -&gt; Product . all ( ) end with context &lt;- Liquex.Context . new ( %{ products : products_resolver } ) , { :ok , document } &lt;- Liquex . parse ( &quot;There are {{ products.size }} products&quot; ) , { result , _ } &lt;- Liquex . render ( document , context ) do result end iex&gt; &quot;There are 5 products&quot; Indifferent access By default, Liquex accesses your maps and structs that may have atom or string (or other type) keys. Liquex will try a string key first. If that fails, it will fall back to using an atom keys. This is similar to how Ruby on Rails handles many of its hashes. This allows you to pass in your structs without having to replace all your keys with string keys. iex&gt; { :ok , template_ast } = Liquex . parse ( &quot;Hello {{ name }}!&quot; ) iex&gt; context = Liquex.Context . new ( %{ name : &quot;World&quot; } ) iex&gt; { content , _context } = Liquex . render ( template_ast , context ) iex&gt; content |&gt; to_string ( ) &quot;Hello World!&quot; Custom filters Liquex contains the full suite of standard Liquid filters, but you may find that there are still filters that you may want to add. Liquex supports adding your own custom filters to the render pipeline. When creating the context for the renderer, set the filter module to your own module. defmodule CustomFilter do # Import all the standard liquid filters use Liquex.Filter def scream ( value , _ ) , do : String . upcase ( value ) &lt;&gt; &quot;!&quot; end context = Liquex.Context . new ( %{ } , filter_module : CustomFilter ) { :ok , template_ast } = Liquex . parse ( &quot;{{&#39;Hello World&#39; | scream}}&quot; { result , _ } = Liquex . render ( template_ast , context ) result |&gt; to_string ( ) iex&gt; &quot;HELLO WORLD!&quot; Custom tags One of the strong points for Liquex is that the tag parser can be extended to support non-standard tags. For example, Liquid used internally for the Shopify site includes a large range of tags that are not supported by the base Ruby gem. These tags could also be added to Liquex by extending the liquid parser. defmodule CustomTag do import NimbleParsec alias Liquex.Parser.Base # Parse &lt;&lt;Custom Tag&gt;&gt; def custom_tag ( combinator \\\\ empty ( ) ) do text = lookahead_not ( string ( &quot;&gt;&gt;&quot; ) ) |&gt; utf8_char ( [ ] ) |&gt; times ( min : 1 ) |&gt; reduce ( { Kernel , :to_string , [ ] } ) |&gt; tag ( :text ) combinator |&gt; ignore ( string ( &quot;&lt;&lt;&quot; ) ) |&gt; optional ( text ) |&gt; ignore ( string ( &quot;&gt;&gt;&quot; ) ) |&gt; tag ( :custom_tag ) end def element ( combinator \\\\ empty ( ) ) do # Add the `custom_tag/1` parsing function to the supported element tag list combinator |&gt; choice ( [ custom_tag ( ) , Base . base_element ( ) ] ) end end defmodule CustomParser do @moduledoc false import NimbleParsec defcombinatorp ( :document , repeat ( CustomTag . element ( ) ) ) defparsec ( :parse , parsec ( :document ) |&gt; eos ( ) ) end iex&gt; Liquex . parse ( &quot;&lt;&lt;Hello World!&gt;&gt;&quot; , CustomParser ) iex&gt; { :ok , [ custom_tag : [ text : [ &quot;Hello World!&quot; ] ] ] } Custom renderer In many cases, if you are building custom tags for your Liquid documents, you probably want to use a custom renderer. Just like the custom filters, you add your module to the context object. defmodule CustomTagRender do def render ( { :custom_tag , contents } , context ) do { result , context } = Liquex . render ( contents , context ) { [ &quot;Custom Tag: &quot; , result ] , context } end # Ignore this tag if we don&#39;t match def render ( _ , _ ) , do : false end context = % Liquex.Context . new ( %{ } , render_module : CustomTagRender ) { :ok , document } = Liquex . parse ( &quot;&lt;&lt;Hello World!&gt;&gt;&quot; , CustomParser ) { result , _ } = Liquex . render ( document , context ) result |&gt; to_string ( ) iex&gt; &quot;Custom Tag: Hello World!&quot; Installation Add the package to your mix.exs file. def deps do [ { :liquex , &quot;~&gt; 0.6&quot; } ] end","ref":"Liquex.html","title":"Liquex","type":"module"},{"doc":"Parses a liquid template string using the given parser . Returns a liquid AST document or the parser error","ref":"Liquex.html#parse/2","title":"Liquex.parse/2","type":"function"},{"doc":"Render a Liquex AST document with the given context","ref":"Liquex.html#render/2","title":"Liquex.render/2","type":"function"},{"doc":"","ref":"Liquex.html#t:document_t/0","title":"Liquex.document_t/0","type":"type"},{"doc":"","ref":"Liquex.Collection.html","title":"Liquex.Collection","type":"protocol"},{"doc":"","ref":"Liquex.Collection.html#limit/2","title":"Liquex.Collection.limit/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#offset/2","title":"Liquex.Collection.offset/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#reverse/1","title":"Liquex.Collection.reverse/1","type":"function"},{"doc":"","ref":"Liquex.Collection.html#sort/1","title":"Liquex.Collection.sort/1","type":"function"},{"doc":"","ref":"Liquex.Collection.html#sort/2","title":"Liquex.Collection.sort/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#sort_case_insensitive/1","title":"Liquex.Collection.sort_case_insensitive/1","type":"function"},{"doc":"","ref":"Liquex.Collection.html#sort_case_insensitive/2","title":"Liquex.Collection.sort_case_insensitive/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#to_enumerable/1","title":"Liquex.Collection.to_enumerable/1","type":"function"},{"doc":"","ref":"Liquex.Collection.html#where/2","title":"Liquex.Collection.where/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#where/3","title":"Liquex.Collection.where/3","type":"function"},{"doc":"","ref":"Liquex.Collection.html#t:t/0","title":"Liquex.Collection.t/0","type":"type"},{"doc":"Stores contextual information for the parser","ref":"Liquex.Context.html","title":"Liquex.Context","type":"module"},{"doc":"Assign a new variable to the context Set a variable named key with the given value in the current context","ref":"Liquex.Context.html#assign/3","title":"Liquex.Context.assign/3","type":"function"},{"doc":"Create a new Context using predefined variables map Returns a new, initialized context object","ref":"Liquex.Context.html#new/2","title":"Liquex.Context.new/2","type":"function"},{"doc":"Assign an error to the error logs","ref":"Liquex.Context.html#push_error/2","title":"Liquex.Context.push_error/2","type":"function"},{"doc":"","ref":"Liquex.Context.html#t:t/0","title":"Liquex.Context.t/0","type":"type"},{"doc":"Contains all the basic filters for Liquid","ref":"Liquex.Filter.html","title":"Liquex.Filter","type":"behaviour"},{"doc":"Returns the absolute value of value . Examples iex&gt; Liquex.Filter . abs ( - 1 , %{ } ) 1 iex&gt; Liquex.Filter . abs ( 1 , %{ } ) 1 iex&gt; Liquex.Filter . abs ( &quot;-1.1&quot; , %{ } ) 1.1","ref":"Liquex.Filter.html#abs/2","title":"Liquex.Filter.abs/2","type":"function"},{"doc":"Appends text to the end of value Examples iex&gt; Liquex.Filter . append ( &quot;myfile&quot; , &quot;.html&quot; , %{ } ) &quot;myfile.html&quot;","ref":"Liquex.Filter.html#append/3","title":"Liquex.Filter.append/3","type":"function"},{"doc":"","ref":"Liquex.Filter.html#c:apply/3","title":"Liquex.Filter.apply/3","type":"callback"},{"doc":"","ref":"Liquex.Filter.html#apply/4","title":"Liquex.Filter.apply/4","type":"function"},{"doc":"Sets a minimum value Examples iex&gt; Liquex.Filter . at_least ( 3 , 5 , %{ } ) 5 iex&gt; Liquex.Filter . at_least ( 5 , 3 , %{ } ) 5","ref":"Liquex.Filter.html#at_least/3","title":"Liquex.Filter.at_least/3","type":"function"},{"doc":"Sets a maximum value Examples iex&gt; Liquex.Filter . at_most ( 4 , 5 , %{ } ) 4 iex&gt; Liquex.Filter . at_most ( 4 , 3 , %{ } ) 3","ref":"Liquex.Filter.html#at_most/3","title":"Liquex.Filter.at_most/3","type":"function"},{"doc":"Capitalizes a string Examples iex&gt; Liquex.Filter . capitalize ( &quot;title&quot; , %{ } ) &quot;Title&quot; iex&gt; Liquex.Filter . capitalize ( &quot;my great title&quot; , %{ } ) &quot;My great title&quot;","ref":"Liquex.Filter.html#capitalize/2","title":"Liquex.Filter.capitalize/2","type":"function"},{"doc":"Rounds value up to the nearest whole number. Liquid tries to convert the input to a number before the filter is applied. Examples iex&gt; Liquex.Filter . ceil ( 1.2 , %{ } ) 2 iex&gt; Liquex.Filter . ceil ( 2.0 , %{ } ) 2 iex&gt; Liquex.Filter . ceil ( 183.357 , %{ } ) 184 iex&gt; Liquex.Filter . ceil ( &quot;3.5&quot; , %{ } ) 4","ref":"Liquex.Filter.html#ceil/2","title":"Liquex.Filter.ceil/2","type":"function"},{"doc":"Removes any nil values from an array. Examples iex&gt; Liquex.Filter . compact ( [ 1 , 2 , nil , 3 ] , %{ } ) [ 1 , 2 , 3 ] iex&gt; Liquex.Filter . compact ( [ 1 , 2 , 3 ] , %{ } ) [ 1 , 2 , 3 ]","ref":"Liquex.Filter.html#compact/2","title":"Liquex.Filter.compact/2","type":"function"},{"doc":"Concatenates (joins together) multiple arrays. The resulting array contains all the items Examples iex&gt; Liquex.Filter . concat ( [ 1 , 2 ] , [ 3 , 4 ] , %{ } ) [ 1 , 2 , 3 , 4 ]","ref":"Liquex.Filter.html#concat/3","title":"Liquex.Filter.concat/3","type":"function"},{"doc":"Converts value timestamp into another date format . The format for this syntax is the same as strftime. The input uses the same format as Ruby’s Time.parse. Examples iex&gt; Liquex.Filter . date ( ~D[2000-01-01] , &quot;%m/%d/%Y&quot; , %{ } ) &quot;01/01/2000&quot; iex&gt; Liquex.Filter . date ( &quot;2000-01-01&quot; , &quot;%m/%d/%Y&quot; , %{ } ) &quot;01/01/2000&quot; iex&gt; Liquex.Filter . date ( &quot;January 1, 2000&quot; , &quot;%m/%d/%Y&quot; , %{ } ) &quot;01/01/2000&quot; iex&gt; Liquex.Filter . date ( &quot;1/2/2000&quot; , &quot;%m/%d/%Y&quot; , %{ } ) &quot;01/02/2000&quot; iex&gt; Liquex.Filter . date ( &quot;March 14, 2016&quot; , &quot;%b %d, %y&quot; , %{ } ) &quot;Mar 14, 16&quot;","ref":"Liquex.Filter.html#date/3","title":"Liquex.Filter.date/3","type":"function"},{"doc":"Allows you to specify a fallback in case a value doesn’t exist. default will show its value if the left side is nil, false, or empty. Examples iex&gt; Liquex.Filter . default ( &quot;1.99&quot; , &quot;2.99&quot; , %{ } ) &quot;1.99&quot; iex&gt; Liquex.Filter . default ( &quot;&quot; , &quot;2.99&quot; , %{ } ) &quot;2.99&quot;","ref":"Liquex.Filter.html#default/3","title":"Liquex.Filter.default/3","type":"function"},{"doc":"Divides a number by another number. Examples The result is rounded down to the nearest integer (that is, the floor) if the divisor is an integer. iex&gt; Liquex.Filter . divided_by ( 16 , 4 , %{ } ) 4 iex&gt; Liquex.Filter . divided_by ( 5 , 3 , %{ } ) 1 iex&gt; Liquex.Filter . divided_by ( 20 , 7.0 , %{ } ) 2.857142857142857","ref":"Liquex.Filter.html#divided_by/3","title":"Liquex.Filter.divided_by/3","type":"function"},{"doc":"Makes each character in a string lowercase. It has no effect on strings which are already all lowercase. Examples iex&gt; Liquex.Filter . downcase ( &quot;Parker Moore&quot; , %{ } ) &quot;parker moore&quot; iex&gt; Liquex.Filter . downcase ( &quot;apple&quot; , %{ } ) &quot;apple&quot;","ref":"Liquex.Filter.html#downcase/2","title":"Liquex.Filter.downcase/2","type":"function"},{"doc":"Escapes a string by replacing characters with escape sequences (so that the string can be used in a URL, for example). It doesn’t change strings that don’t have anything to escape. Examples iex&gt; Liquex.Filter . escape ( &quot;Have you read &#39;James &amp; the Giant Peach&#39;?&quot; , %{ } ) &quot;Have you read &amp;apos;James &amp;amp; the Giant Peach&amp;apos;?&quot; iex&gt; Liquex.Filter . escape ( &quot;Tetsuro Takara&quot; , %{ } ) &quot;Tetsuro Takara&quot;","ref":"Liquex.Filter.html#escape/2","title":"Liquex.Filter.escape/2","type":"function"},{"doc":"Escapes a string by replacing characters with escape sequences (so that the string can be used in a URL, for example). It doesn’t change strings that don’t have anything to escape. Examples iex&gt; Liquex.Filter . escape_once ( &quot;1 &amp;lt; 2 &amp;amp; 3&quot; , %{ } ) &quot;1 &amp;lt; 2 &amp;amp; 3&quot;","ref":"Liquex.Filter.html#escape_once/2","title":"Liquex.Filter.escape_once/2","type":"function"},{"doc":"","ref":"Liquex.Filter.html#filter_name/1","title":"Liquex.Filter.filter_name/1","type":"function"},{"doc":"Returns the first item of an array. Examples iex&gt; Liquex.Filter . first ( [ 1 , 2 , 3 ] , %{ } ) 1 iex&gt; Liquex.Filter . first ( [ ] , %{ } ) nil","ref":"Liquex.Filter.html#first/2","title":"Liquex.Filter.first/2","type":"function"},{"doc":"Rounds the input down to the nearest whole number. Liquid tries to convert the input to a number before the filter is applied. Examples iex&gt; Liquex.Filter . floor ( 1.2 , %{ } ) 1 iex&gt; Liquex.Filter . floor ( 2.0 , %{ } ) 2","ref":"Liquex.Filter.html#floor/2","title":"Liquex.Filter.floor/2","type":"function"},{"doc":"Combines the items in values into a single string using joiner as a separator. Examples iex&gt; Liquex.Filter . join ( ~w(John Paul George Ringo) , &quot; and &quot; , %{ } ) &quot;John and Paul and George and Ringo&quot;","ref":"Liquex.Filter.html#join/3","title":"Liquex.Filter.join/3","type":"function"},{"doc":"Returns the last item of arr . Examples iex&gt; Liquex.Filter . last ( [ 1 , 2 , 3 ] , %{ } ) 3 iex&gt; Liquex.Filter . first ( [ ] , %{ } ) nil","ref":"Liquex.Filter.html#last/2","title":"Liquex.Filter.last/2","type":"function"},{"doc":"Removes all whitespace (tabs, spaces, and newlines) from the left side of a string. It does not affect spaces between words. Examples iex&gt; Liquex.Filter . lstrip ( &quot; So much room for activities! &quot; , %{ } ) &quot;So much room for activities! &quot;","ref":"Liquex.Filter.html#lstrip/2","title":"Liquex.Filter.lstrip/2","type":"function"},{"doc":"Creates an array ( arr ) of values by extracting the values of a named property from another object ( key ). Examples iex&gt; Liquex.Filter . map ( [ %{ &quot;a&quot; =&gt; 1 } , %{ &quot;a&quot; =&gt; 2 , &quot;b&quot; =&gt; 1 } ] , &quot;a&quot; , %{ } ) [ 1 , 2 ]","ref":"Liquex.Filter.html#map/3","title":"Liquex.Filter.map/3","type":"function"},{"doc":"Subtracts a number from another number. Examples iex&gt; Liquex.Filter . minus ( 4 , 2 , %{ } ) 2 iex&gt; Liquex.Filter . minus ( 183.357 , 12 , %{ } ) 171.357","ref":"Liquex.Filter.html#minus/3","title":"Liquex.Filter.minus/3","type":"function"},{"doc":"Returns the remainder of a division operation. Examples iex&gt; Liquex.Filter . modulo ( 3 , 2 , %{ } ) 1 iex&gt; Liquex.Filter . modulo ( 183.357 , 12 , %{ } ) 3.357","ref":"Liquex.Filter.html#modulo/3","title":"Liquex.Filter.modulo/3","type":"function"},{"doc":"Replaces every newline ( ) in a string with an HTML line break (&lt;br /&gt;). Examples iex&gt; Liquex.Filter . newline_to_br ( &quot; \\n Hello \\n there \\n &quot; , %{ } ) &quot;&lt;br /&gt; \\n Hello&lt;br /&gt; \\n there&lt;br /&gt; \\n &quot;","ref":"Liquex.Filter.html#newline_to_br/2","title":"Liquex.Filter.newline_to_br/2","type":"function"},{"doc":"Adds a number to another number. Examples iex&gt; Liquex.Filter . plus ( 4 , 2 , %{ } ) 6 iex&gt; Liquex.Filter . plus ( 183.357 , 12 , %{ } ) 195.357","ref":"Liquex.Filter.html#plus/3","title":"Liquex.Filter.plus/3","type":"function"},{"doc":"Adds the specified string to the beginning of another string. Examples iex&gt; Liquex.Filter . prepend ( &quot;apples, oranges, and bananas&quot; , &quot;Some fruit: &quot; , %{ } ) &quot;Some fruit: apples, oranges, and bananas&quot; iex&gt; Liquex.Filter . prepend ( &quot;/index.html&quot; , &quot;example.com&quot; , %{ } ) &quot;example.com/index.html&quot;","ref":"Liquex.Filter.html#prepend/3","title":"Liquex.Filter.prepend/3","type":"function"},{"doc":"Removes every occurrence of the specified substring from a string. Examples iex&gt; Liquex.Filter . remove ( &quot;I strained to see the train through the rain&quot; , &quot;rain&quot; , %{ } ) &quot;I sted to see the t through the &quot;","ref":"Liquex.Filter.html#remove/3","title":"Liquex.Filter.remove/3","type":"function"},{"doc":"Removes every occurrence of the specified substring from a string. Examples iex&gt; Liquex.Filter . remove_first ( &quot;I strained to see the train through the rain&quot; , &quot;rain&quot; , %{ } ) &quot;I sted to see the train through the rain&quot;","ref":"Liquex.Filter.html#remove_first/3","title":"Liquex.Filter.remove_first/3","type":"function"},{"doc":"Replaces every occurrence of the first argument in a string with the second argument. Examples iex&gt; Liquex.Filter . replace ( &quot;Take my protein pills and put my helmet on&quot; , &quot;my&quot; , &quot;your&quot; , %{ } ) &quot;Take your protein pills and put your helmet on&quot;","ref":"Liquex.Filter.html#replace/4","title":"Liquex.Filter.replace/4","type":"function"},{"doc":"Replaces only the first occurrence of the first argument in a string with the second argument. Examples iex&gt; Liquex.Filter . replace_first ( &quot;Take my protein pills and put my helmet on&quot; , &quot;my&quot; , &quot;your&quot; , %{ } ) &quot;Take your protein pills and put my helmet on&quot;","ref":"Liquex.Filter.html#replace_first/4","title":"Liquex.Filter.replace_first/4","type":"function"},{"doc":"Reverses the order of the items in an array. reverse cannot reverse a string. Examples iex&gt; Liquex.Filter . reverse ( ~w(apples oranges peaches plums) , %{ } ) [ &quot;plums&quot; , &quot;peaches&quot; , &quot;oranges&quot; , &quot;apples&quot; ]","ref":"Liquex.Filter.html#reverse/2","title":"Liquex.Filter.reverse/2","type":"function"},{"doc":"Rounds a number to the nearest integer or, if a number is passed as an argument, to that number of decimal places. Examples iex&gt; Liquex.Filter . round ( 1 , %{ } ) 1 iex&gt; Liquex.Filter . round ( 1.2 , %{ } ) 1 iex&gt; Liquex.Filter . round ( 2.7 , %{ } ) 3 iex&gt; Liquex.Filter . round ( 183.357 , 2 , %{ } ) 183.36","ref":"Liquex.Filter.html#round/3","title":"Liquex.Filter.round/3","type":"function"},{"doc":"Removes all whitespace (tabs, spaces, and newlines) from the right side of a string. It does not affect spaces between words. Examples iex&gt; Liquex.Filter . rstrip ( &quot; So much room for activities! &quot; , %{ } ) &quot; So much room for activities!&quot;","ref":"Liquex.Filter.html#rstrip/2","title":"Liquex.Filter.rstrip/2","type":"function"},{"doc":"Returns the number of characters in a string or the number of items in an array. Examples iex&gt; Liquex.Filter . size ( &quot;Ground control to Major Tom.&quot; , %{ } ) 28 iex&gt; Liquex.Filter . size ( ~w(apples oranges peaches plums) , %{ } ) 4","ref":"Liquex.Filter.html#size/2","title":"Liquex.Filter.size/2","type":"function"},{"doc":"Returns a substring of 1 character beginning at the index specified by the first argument. An optional second argument specifies the length of the substring to be returned. Examples iex&gt; Liquex.Filter . slice ( &quot;Liquid&quot; , 0 , %{ } ) &quot;L&quot; iex&gt; Liquex.Filter . slice ( &quot;Liquid&quot; , 2 , %{ } ) &quot;q&quot; iex&gt; Liquex.Filter . slice ( &quot;Liquid&quot; , 2 , 5 , %{ } ) &quot;quid&quot; If the first argument is a negative number, the indices are counted from the end of the string: Examples iex&gt; Liquex.Filter . slice ( &quot;Liquid&quot; , - 3 , 2 , %{ } ) &quot;ui&quot;","ref":"Liquex.Filter.html#slice/4","title":"Liquex.Filter.slice/4","type":"function"},{"doc":"Sorts items in an array in case-sensitive order. Examples iex&gt; Liquex.Filter . sort ( [ &quot;zebra&quot; , &quot;octopus&quot; , &quot;giraffe&quot; , &quot;Sally Snake&quot; ] , %{ } ) [ &quot;Sally Snake&quot; , &quot;giraffe&quot; , &quot;octopus&quot; , &quot;zebra&quot; ]","ref":"Liquex.Filter.html#sort/2","title":"Liquex.Filter.sort/2","type":"function"},{"doc":"","ref":"Liquex.Filter.html#sort/3","title":"Liquex.Filter.sort/3","type":"function"},{"doc":"Sorts items in an array in case-insensitive order. Examples iex&gt; Liquex.Filter . sort_natural ( [ &quot;zebra&quot; , &quot;octopus&quot; , &quot;giraffe&quot; , &quot;Sally Snake&quot; ] , %{ } ) [ &quot;giraffe&quot; , &quot;octopus&quot; , &quot;Sally Snake&quot; , &quot;zebra&quot; ]","ref":"Liquex.Filter.html#sort_natural/2","title":"Liquex.Filter.sort_natural/2","type":"function"},{"doc":"","ref":"Liquex.Filter.html#sort_natural/3","title":"Liquex.Filter.sort_natural/3","type":"function"},{"doc":"Divides a string into an array using the argument as a separator. split is commonly used to convert comma-separated items from a string to an array. Examples iex&gt; Liquex.Filter . split ( &quot;John, Paul, George, Ringo&quot; , &quot;, &quot; , %{ } ) [ &quot;John&quot; , &quot;Paul&quot; , &quot;George&quot; , &quot;Ringo&quot; ]","ref":"Liquex.Filter.html#split/3","title":"Liquex.Filter.split/3","type":"function"},{"doc":"Removes all whitespace (tabs, spaces, and newlines) from both the left and right side of a string. It does not affect spaces between words. Examples iex&gt; Liquex.Filter . strip ( &quot; So much room for activities! &quot; , %{ } ) &quot;So much room for activities!&quot;","ref":"Liquex.Filter.html#strip/2","title":"Liquex.Filter.strip/2","type":"function"},{"doc":"Removes any HTML tags from a string. Examples iex&gt; Liquex.Filter . strip_html ( &quot;Have &lt;em&gt;you&lt;/em&gt; read &lt;strong&gt;Ulysses&lt;/strong&gt;?&quot; , %{ } ) &quot;Have you read Ulysses?&quot;","ref":"Liquex.Filter.html#strip_html/2","title":"Liquex.Filter.strip_html/2","type":"function"},{"doc":"Removes any newline characters (line breaks) from a string. Examples iex&gt; Liquex.Filter . strip_newlines ( &quot;Hello \\n there&quot; , %{ } ) &quot;Hellothere&quot;","ref":"Liquex.Filter.html#strip_newlines/2","title":"Liquex.Filter.strip_newlines/2","type":"function"},{"doc":"Multiplies a number by another number. Examples iex&gt; Liquex.Filter . times ( 3 , 4 , %{ } ) 12 iex&gt; Liquex.Filter . times ( 24 , 7 , %{ } ) 168 iex&gt; Liquex.Filter . times ( 183.357 , 12 , %{ } ) 2200.284","ref":"Liquex.Filter.html#times/3","title":"Liquex.Filter.times/3","type":"function"},{"doc":"Shortens a string down to the number of characters passed as an argument. If the specified number of characters is less than the length of the string, an ellipsis (…) is appended to the string and is included in the character count. Examples iex&gt; Liquex.Filter . truncate ( &quot;Ground control to Major Tom.&quot; , 20 , %{ } ) &quot;Ground control to...&quot; iex&gt; Liquex.Filter . truncate ( &quot;Ground control to Major Tom.&quot; , 25 , &quot;, and so on&quot; , %{ } ) &quot;Ground control, and so on&quot; iex&gt; Liquex.Filter . truncate ( &quot;Ground control to Major Tom.&quot; , 20 , &quot;&quot; , %{ } ) &quot;Ground control to Ma&quot;","ref":"Liquex.Filter.html#truncate/4","title":"Liquex.Filter.truncate/4","type":"function"},{"doc":"Shortens a string down to the number of characters passed as an argument. If the specified number of characters is less than the length of the string, an ellipsis (…) is appended to the string and is included in the character count. Examples iex&gt; Liquex.Filter . truncatewords ( &quot;Ground control to Major Tom.&quot; , 3 , %{ } ) &quot;Ground control to...&quot; iex&gt; Liquex.Filter . truncatewords ( &quot;Ground control to Major Tom.&quot; , 3 , &quot;--&quot; , %{ } ) &quot;Ground control to--&quot; iex&gt; Liquex.Filter . truncatewords ( &quot;Ground control to Major Tom.&quot; , 3 , &quot;&quot; , %{ } ) &quot;Ground control to&quot;","ref":"Liquex.Filter.html#truncatewords/4","title":"Liquex.Filter.truncatewords/4","type":"function"},{"doc":"Removes any duplicate elements in an array. Examples iex&gt; Liquex.Filter . uniq ( ~w(ants bugs bees bugs ants) , %{ } ) [ &quot;ants&quot; , &quot;bugs&quot; , &quot;bees&quot; ]","ref":"Liquex.Filter.html#uniq/2","title":"Liquex.Filter.uniq/2","type":"function"},{"doc":"Makes each character in a string uppercase. It has no effect on strings which are already all uppercase. Examples iex&gt; Liquex.Filter . upcase ( &quot;Parker Moore&quot; , %{ } ) &quot;PARKER MOORE&quot; iex&gt; Liquex.Filter . upcase ( &quot;APPLE&quot; , %{ } ) &quot;APPLE&quot;","ref":"Liquex.Filter.html#upcase/2","title":"Liquex.Filter.upcase/2","type":"function"},{"doc":"Decodes a string that has been encoded as a URL or by url_encode/2. Examples iex&gt; Liquex.Filter . url_decode ( &quot;%27Stop%21%27+said+Fred&quot; , %{ } ) &quot;&#39;Stop!&#39; said Fred&quot;","ref":"Liquex.Filter.html#url_decode/2","title":"Liquex.Filter.url_decode/2","type":"function"},{"doc":"Decodes a string that has been encoded as a URL or by url_encode/2. Examples iex&gt; Liquex.Filter . url_encode ( &quot;john@liquid.com&quot; , %{ } ) &quot;john%40liquid.com&quot; iex&gt; Liquex.Filter . url_encode ( &quot;Tetsuro Takara&quot; , %{ } ) &quot;Tetsuro+Takara&quot;","ref":"Liquex.Filter.html#url_encode/2","title":"Liquex.Filter.url_encode/2","type":"function"},{"doc":"Creates an array including only the objects with a given truthy property value Examples iex&gt; Liquex.Filter . where ( [ %{ &quot;b&quot; =&gt; true , &quot;value&quot; =&gt; 1 } , %{ &quot;b&quot; =&gt; 1 , &quot;value&quot; =&gt; 2 } , %{ &quot;b&quot; =&gt; false , &quot;value&quot; =&gt; 3 } ] , &quot;b&quot; , %{ } ) [ %{ &quot;b&quot; =&gt; true , &quot;value&quot; =&gt; 1 } , %{ &quot;b&quot; =&gt; 1 , &quot;value&quot; =&gt; 2 } ]","ref":"Liquex.Filter.html#where/3","title":"Liquex.Filter.where/3","type":"function"},{"doc":"Creates an array including only the objects with a given property value, or any truthy value by default. Examples iex&gt; Liquex.Filter . where ( [ %{ &quot;b&quot; =&gt; 2 } , %{ &quot;b&quot; =&gt; 1 } ] , &quot;b&quot; , 1 , %{ } ) [ %{ &quot;b&quot; =&gt; 1 } ]","ref":"Liquex.Filter.html#where/4","title":"Liquex.Filter.where/4","type":"function"},{"doc":"","ref":"Liquex.Filter.html#t:filter_t/0","title":"Liquex.Filter.filter_t/0","type":"type"},{"doc":"Liquid parser","ref":"Liquex.Parser.html","title":"Liquex.Parser","type":"module"},{"doc":"Parses the given binary as parse. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the parse (start position) as {line, column_on_line} . Options :byte_offset - the byte offset for the whole binary, defaults to 0 :line - the line and the byte offset into that line, defaults to {1, byte_offset} :context - the initial context value. It will be converted to a map","ref":"Liquex.Parser.html#parse/2","title":"Liquex.Parser.parse/2","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html","title":"Liquex.Parser.LiteralHelper","type":"module"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__0/6","title":"Liquex.Parser.LiteralHelper.argument__0/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__1/6","title":"Liquex.Parser.LiteralHelper.argument__1/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__10/6","title":"Liquex.Parser.LiteralHelper.argument__10/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__100/6","title":"Liquex.Parser.LiteralHelper.argument__100/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__101/6","title":"Liquex.Parser.LiteralHelper.argument__101/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__102/6","title":"Liquex.Parser.LiteralHelper.argument__102/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__103/6","title":"Liquex.Parser.LiteralHelper.argument__103/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__104/6","title":"Liquex.Parser.LiteralHelper.argument__104/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__105/6","title":"Liquex.Parser.LiteralHelper.argument__105/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__106/6","title":"Liquex.Parser.LiteralHelper.argument__106/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__107/6","title":"Liquex.Parser.LiteralHelper.argument__107/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__108/6","title":"Liquex.Parser.LiteralHelper.argument__108/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__109/6","title":"Liquex.Parser.LiteralHelper.argument__109/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__11/6","title":"Liquex.Parser.LiteralHelper.argument__11/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__110/6","title":"Liquex.Parser.LiteralHelper.argument__110/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__111/6","title":"Liquex.Parser.LiteralHelper.argument__111/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__112/6","title":"Liquex.Parser.LiteralHelper.argument__112/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__113/6","title":"Liquex.Parser.LiteralHelper.argument__113/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__114/6","title":"Liquex.Parser.LiteralHelper.argument__114/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__115/6","title":"Liquex.Parser.LiteralHelper.argument__115/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__116/6","title":"Liquex.Parser.LiteralHelper.argument__116/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__117/6","title":"Liquex.Parser.LiteralHelper.argument__117/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__118/6","title":"Liquex.Parser.LiteralHelper.argument__118/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__119/6","title":"Liquex.Parser.LiteralHelper.argument__119/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__12/6","title":"Liquex.Parser.LiteralHelper.argument__12/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__120/6","title":"Liquex.Parser.LiteralHelper.argument__120/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__121/6","title":"Liquex.Parser.LiteralHelper.argument__121/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__122/6","title":"Liquex.Parser.LiteralHelper.argument__122/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__123/6","title":"Liquex.Parser.LiteralHelper.argument__123/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__124/6","title":"Liquex.Parser.LiteralHelper.argument__124/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__125/6","title":"Liquex.Parser.LiteralHelper.argument__125/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__126/6","title":"Liquex.Parser.LiteralHelper.argument__126/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__127/6","title":"Liquex.Parser.LiteralHelper.argument__127/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__13/6","title":"Liquex.Parser.LiteralHelper.argument__13/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__14/6","title":"Liquex.Parser.LiteralHelper.argument__14/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__15/6","title":"Liquex.Parser.LiteralHelper.argument__15/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__16/6","title":"Liquex.Parser.LiteralHelper.argument__16/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__17/6","title":"Liquex.Parser.LiteralHelper.argument__17/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__18/6","title":"Liquex.Parser.LiteralHelper.argument__18/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__19/6","title":"Liquex.Parser.LiteralHelper.argument__19/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__2/6","title":"Liquex.Parser.LiteralHelper.argument__2/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__20/6","title":"Liquex.Parser.LiteralHelper.argument__20/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__21/6","title":"Liquex.Parser.LiteralHelper.argument__21/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__22/6","title":"Liquex.Parser.LiteralHelper.argument__22/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__23/6","title":"Liquex.Parser.LiteralHelper.argument__23/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__24/6","title":"Liquex.Parser.LiteralHelper.argument__24/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__25/6","title":"Liquex.Parser.LiteralHelper.argument__25/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__26/6","title":"Liquex.Parser.LiteralHelper.argument__26/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__27/6","title":"Liquex.Parser.LiteralHelper.argument__27/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__28/6","title":"Liquex.Parser.LiteralHelper.argument__28/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__29/6","title":"Liquex.Parser.LiteralHelper.argument__29/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__3/6","title":"Liquex.Parser.LiteralHelper.argument__3/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__30/6","title":"Liquex.Parser.LiteralHelper.argument__30/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__31/6","title":"Liquex.Parser.LiteralHelper.argument__31/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__32/6","title":"Liquex.Parser.LiteralHelper.argument__32/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__33/6","title":"Liquex.Parser.LiteralHelper.argument__33/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__34/6","title":"Liquex.Parser.LiteralHelper.argument__34/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__35/6","title":"Liquex.Parser.LiteralHelper.argument__35/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__36/6","title":"Liquex.Parser.LiteralHelper.argument__36/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__37/6","title":"Liquex.Parser.LiteralHelper.argument__37/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__38/6","title":"Liquex.Parser.LiteralHelper.argument__38/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__39/6","title":"Liquex.Parser.LiteralHelper.argument__39/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__4/6","title":"Liquex.Parser.LiteralHelper.argument__4/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__40/6","title":"Liquex.Parser.LiteralHelper.argument__40/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__41/6","title":"Liquex.Parser.LiteralHelper.argument__41/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__42/6","title":"Liquex.Parser.LiteralHelper.argument__42/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__43/6","title":"Liquex.Parser.LiteralHelper.argument__43/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__44/6","title":"Liquex.Parser.LiteralHelper.argument__44/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__45/6","title":"Liquex.Parser.LiteralHelper.argument__45/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__46/6","title":"Liquex.Parser.LiteralHelper.argument__46/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__47/6","title":"Liquex.Parser.LiteralHelper.argument__47/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__48/6","title":"Liquex.Parser.LiteralHelper.argument__48/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__49/6","title":"Liquex.Parser.LiteralHelper.argument__49/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__5/6","title":"Liquex.Parser.LiteralHelper.argument__5/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__50/6","title":"Liquex.Parser.LiteralHelper.argument__50/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__51/6","title":"Liquex.Parser.LiteralHelper.argument__51/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__52/6","title":"Liquex.Parser.LiteralHelper.argument__52/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__53/6","title":"Liquex.Parser.LiteralHelper.argument__53/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__54/6","title":"Liquex.Parser.LiteralHelper.argument__54/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__55/6","title":"Liquex.Parser.LiteralHelper.argument__55/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__56/6","title":"Liquex.Parser.LiteralHelper.argument__56/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__57/6","title":"Liquex.Parser.LiteralHelper.argument__57/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__58/6","title":"Liquex.Parser.LiteralHelper.argument__58/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__59/6","title":"Liquex.Parser.LiteralHelper.argument__59/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__6/6","title":"Liquex.Parser.LiteralHelper.argument__6/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__60/6","title":"Liquex.Parser.LiteralHelper.argument__60/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__61/6","title":"Liquex.Parser.LiteralHelper.argument__61/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__62/6","title":"Liquex.Parser.LiteralHelper.argument__62/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__63/6","title":"Liquex.Parser.LiteralHelper.argument__63/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__64/6","title":"Liquex.Parser.LiteralHelper.argument__64/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__65/6","title":"Liquex.Parser.LiteralHelper.argument__65/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__66/6","title":"Liquex.Parser.LiteralHelper.argument__66/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__67/6","title":"Liquex.Parser.LiteralHelper.argument__67/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__68/6","title":"Liquex.Parser.LiteralHelper.argument__68/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__69/6","title":"Liquex.Parser.LiteralHelper.argument__69/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__7/6","title":"Liquex.Parser.LiteralHelper.argument__7/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__70/6","title":"Liquex.Parser.LiteralHelper.argument__70/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__71/6","title":"Liquex.Parser.LiteralHelper.argument__71/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__72/6","title":"Liquex.Parser.LiteralHelper.argument__72/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__73/6","title":"Liquex.Parser.LiteralHelper.argument__73/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__74/6","title":"Liquex.Parser.LiteralHelper.argument__74/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__75/6","title":"Liquex.Parser.LiteralHelper.argument__75/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__76/6","title":"Liquex.Parser.LiteralHelper.argument__76/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__77/6","title":"Liquex.Parser.LiteralHelper.argument__77/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__78/6","title":"Liquex.Parser.LiteralHelper.argument__78/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__79/6","title":"Liquex.Parser.LiteralHelper.argument__79/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__8/6","title":"Liquex.Parser.LiteralHelper.argument__8/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__80/6","title":"Liquex.Parser.LiteralHelper.argument__80/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__81/6","title":"Liquex.Parser.LiteralHelper.argument__81/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__82/6","title":"Liquex.Parser.LiteralHelper.argument__82/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__83/6","title":"Liquex.Parser.LiteralHelper.argument__83/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__84/6","title":"Liquex.Parser.LiteralHelper.argument__84/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__85/6","title":"Liquex.Parser.LiteralHelper.argument__85/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__86/6","title":"Liquex.Parser.LiteralHelper.argument__86/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__87/6","title":"Liquex.Parser.LiteralHelper.argument__87/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__88/6","title":"Liquex.Parser.LiteralHelper.argument__88/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__89/6","title":"Liquex.Parser.LiteralHelper.argument__89/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__9/6","title":"Liquex.Parser.LiteralHelper.argument__9/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__90/6","title":"Liquex.Parser.LiteralHelper.argument__90/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__91/6","title":"Liquex.Parser.LiteralHelper.argument__91/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__92/6","title":"Liquex.Parser.LiteralHelper.argument__92/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__93/6","title":"Liquex.Parser.LiteralHelper.argument__93/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__94/6","title":"Liquex.Parser.LiteralHelper.argument__94/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__95/6","title":"Liquex.Parser.LiteralHelper.argument__95/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__96/6","title":"Liquex.Parser.LiteralHelper.argument__96/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__97/6","title":"Liquex.Parser.LiteralHelper.argument__97/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__98/6","title":"Liquex.Parser.LiteralHelper.argument__98/6","type":"function"},{"doc":"","ref":"Liquex.Parser.LiteralHelper.html#argument__99/6","title":"Liquex.Parser.LiteralHelper.argument__99/6","type":"function"},{"doc":"Helper methods for maps","ref":"Liquex.Represent.html","title":"Liquex.Represent","type":"module"},{"doc":"Expands a previously represented object. Useful when the represented object contains lazy fields. This can be useful for generating JSON values from a represented object. For example, if you had a dump filter that dumped a value to the page as JSON, you would use this function so that lazy functions get represented correctly instead of as functions.","ref":"Liquex.Represent.html#expand/1","title":"Liquex.Represent.expand/1","type":"function"},{"doc":"","ref":"Liquex.Represent.html#is_lazy_object/1","title":"Liquex.Represent.is_lazy_object/1","type":"macro"},{"doc":"Convert any object and deeply maps atom keys to strings The value deep determines if it should eagerly represent the object. If set to false, it will return a function for any nested objects. Lazy values are automatically evaluated in the Liquid rendering engine.","ref":"Liquex.Represent.html#represent/2","title":"Liquex.Represent.represent/2","type":"function"},{"doc":"","ref":"Liquex.Representable.html","title":"Liquex.Representable","type":"protocol"},{"doc":"","ref":"Liquex.Representable.html#is_lazy/1","title":"Liquex.Representable.is_lazy/1","type":"function"},{"doc":"","ref":"Liquex.Representable.html#represent/2","title":"Liquex.Representable.represent/2","type":"function"},{"doc":"","ref":"Liquex.Representable.html#t:t/0","title":"Liquex.Representable.t/0","type":"type"},{"doc":"","ref":"LiquexError.html","title":"LiquexError","type":"exception"},{"doc":"","ref":"LiquexError.html#t:t/0","title":"LiquexError.t/0","type":"type"},{"doc":"Liquex A Liquid template parser for Elixir. Liquid template renderer for Elixir with 100% compatibility with the Liquid gem by Shopify . If you find that this library is not byte for byte equivalent to liquid, please open an issue .","ref":"readme.html","title":"Liquex","type":"extras"},{"doc":"The package is available in Hex and can be installed by adding liquex to your list of dependencies in mix.exs : def deps do [ { :liquex , &quot;~&gt; 0.6&quot; } ] end Documentation can be found at https://hexdocs.pm/liquex .","ref":"readme.html#installation","title":"Liquex - Installation","type":"extras"},{"doc":"iex&gt; { :ok , template_ast } = Liquex . parse ( &quot;Hello {{ name }}!&quot; ) iex&gt; context = Liquex.Context . new ( %{ &quot;name&quot; =&gt; &quot;World&quot; } ) iex&gt; { content , _context } = Liquex . render ( template_ast , context ) iex&gt; content |&gt; to_string ( ) &quot;Hello World!&quot;","ref":"readme.html#basic-usage","title":"Liquex - Basic Usage","type":"extras"},{"doc":"Currently, all standard Liquid tags, filters, and types are fully supported. Liquex can be considered a drop in replacement of the Liquid gem, but in Elixir. Supported: [x] All standard tags and filters [x] Custom tags and filters [x] Lazy variable resolvers [x] Date processing parity with Ruby [x] Access maps with atom or string keys [x] Whitespace control","ref":"readme.html#supported-features","title":"Liquex - Supported features","type":"extras"},{"doc":"Liquex allows resolver functions for variables that may require some extra work to generate. For example, Shopify has variables for things like available products. Pulling all products every time would be too expensive to do on every render. Instead, it would be better to lazily pull that information as needed. Instead of adding the product list to the context variable map, you can add a function to the variable map. If a function is accessed in the variable map, it is executed. products_resolver = fn _parent -&gt; Product . all ( ) end with context &lt;- Liquex.Context . new ( %{ products : products_resolver } ) , { :ok , document } &lt;- Liquex . parse ( &quot;There are {{ products.size }} products&quot; ) , { result , _ } &lt;- Liquex . render ( document , context ) do result end iex&gt; &quot;There are 5 products&quot;","ref":"readme.html#lazy-variables","title":"Liquex - Lazy variables","type":"extras"},{"doc":"By default, Liquex accesses your maps and structs that may have atom or string (or other type) keys. Liquex will try a string key first. If that fails, it will fall back to using an atom keys. This is similar to how Ruby on Rails handles many of its hashes. This allows you to pass in your structs without having to replace all your keys with string keys. iex&gt; { :ok , template_ast } = Liquex . parse ( &quot;Hello {{ name }}!&quot; ) iex&gt; context = Liquex.Context . new ( %{ name : &quot;World&quot; } ) iex&gt; { content , _context } = Liquex . render ( template_ast , context ) iex&gt; content |&gt; to_string ( ) &quot;Hello World!&quot;","ref":"readme.html#indifferent-access","title":"Liquex - Indifferent access","type":"extras"},{"doc":"Liquex contains the full suite of standard Liquid filters, but you may find that there are still filters that you may want to add. Liquex supports adding your own custom filters to the render pipeline. When creating the context for the renderer, set the filter module to your own module. defmodule CustomFilter do # Import all the standard liquid filters use Liquex.Filter def scream ( value , _ ) , do : String . upcase ( value ) &lt;&gt; &quot;!&quot; end context = Liquex.Context . new ( %{ } , filter_module : CustomFilter ) { :ok , template_ast } = Liquex . parse ( &quot;{{&#39;Hello World&#39; | scream}}&quot; { result , _ } = Liquex . render ( template_ast , context ) result |&gt; to_string ( ) iex&gt; &quot;HELLO WORLD!&quot;","ref":"readme.html#custom-filters","title":"Liquex - Custom filters","type":"extras"},{"doc":"One of the strong points for Liquex is that the tag parser can be extended to support non-standard tags. For example, Liquid used internally for the Shopify site includes a large range of tags that are not supported by the base Ruby gem. These tags could also be added to Liquex by extending the liquid parser. defmodule CustomTag do import NimbleParsec alias Liquex.Parser.Base # Parse &lt;&lt;Custom Tag&gt;&gt; def custom_tag ( combinator \\\\ \\\\ empty ( ) ) do text = lookahead_not ( string ( &quot;&gt;&gt;&quot; ) ) |&gt; utf8_char ( [ ] ) |&gt; times ( min : 1 ) |&gt; reduce ( { Kernel , :to_string , [ ] } ) |&gt; tag ( :text ) combinator |&gt; ignore ( string ( &quot;&lt;&lt;&quot; ) ) |&gt; optional ( text ) |&gt; ignore ( string ( &quot;&gt;&gt;&quot; ) ) |&gt; tag ( :custom_tag ) end def element ( combinator \\\\ \\\\ empty ( ) ) do # Add the `custom_tag/1` parsing function to the supported element tag list combinator |&gt; choice ( [ custom_tag ( ) , Base . base_element ( ) ] ) end end defmodule CustomParser do @moduledoc false import NimbleParsec defcombinatorp ( :document , repeat ( CustomTag . element ( ) ) ) defparsec ( :parse , parsec ( :document ) |&gt; eos ( ) ) end iex&gt; Liquex . parse ( &quot;&lt;&lt;Hello World!&gt;&gt;&quot; , CustomParser ) iex&gt; { :ok , [ custom_tag : [ text : [ &quot;Hello World!&quot; ] ] ] }","ref":"readme.html#custom-tags","title":"Liquex - Custom tags","type":"extras"},{"doc":"In many cases, if you are building custom tags for your Liquid documents, you probably want to use a custom renderer. Just like the custom filters, you add your module to the context object. defmodule CustomTagRender do def render ( { :custom_tag , contents } , context ) do { result , context } = Liquex . render ( contents , context ) { [ &quot;Custom Tag: &quot; , result ] , context } end # Ignore this tag if we don&#39;t match def render ( _ , _ ) , do : false end context = % Liquex.Context . new ( %{ } , render_module : CustomTagRender ) { :ok , document } = Liquex . parse ( &quot;&lt;&lt;Hello World!&gt;&gt;&quot; , CustomParser ) { result , _ } = Liquex . render ( document , context ) result |&gt; to_string ( ) iex&gt; &quot;Custom Tag: Hello World!&quot;","ref":"readme.html#custom-renderer","title":"Liquex - Custom renderer","type":"extras"}]